### Function

# EDataServerUI4 trust_prompt_run_modal

since: 3.16

#### Declaration [src]

    ETrustPromptResponse
    e_trust_prompt_run_modal (
      GtkWindow* parent,
      const gchar* source_extension,
      const gchar* source_display_name,
      const gchar* host,
      const gchar* certificate_pem,
      GTlsCertificateFlags certificate_errors,
      const gchar* error_text
    )

#### Description [src]

Runs modal (doesn’t return until the dialog is closed) a trust prompt dialog, it is a prompt whether a user wants to accept or reject the `certificate_pem` for the `host` due to the `certificate_errors` errors.

The pair `source_extension` and `source_display_name` influences the trust prompt message. If both are set, then the message also contains which source failed to connect according to these two arguments.

The dialog can contain a custom error text, passed in as `error_text`. The error might be a detailed error string returned by the server. If set, it is prefixed with “Detailed error:” string.

Available since: 3.16

#### Parameters

`parent`

  Type: `GtkWindow`

  A `GtkWindow` to use as a parent for the trust prompt dialog.

  The data is owned by the caller of the function.

`source_extension`

  Type: `const gchar*`

  An `ESource` extension, to identify a kind of the source; or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`source_display_name`

  Type: `const gchar*`

  An `ESource` display name, to identify what prompts; or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`host`

  Type: `const gchar*`

  A host name to which the certificate belongs.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`certificate_pem`

  Type: `const gchar*`

  A PEM-encoded certificate for which to show the trust prompt.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`certificate_errors`

  Type: `GTlsCertificateFlags`

  Errors of the `certificate_pem`.

`error_text`

  Type: `const gchar*`

  An optional error text to show in the dialog; can be `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

#### Return value

Type: `ETrustPromptResponse`

A code of the user’s choice. The #E_TRUST_PROMPT_RESPONSE_UNKNOWN is returned, when the user cancelled the trust prompt dialog.